package prueba;

import entradaSalida.SalidaPorDefecto;
import estructurasLineales.ListaDinamica;
import estructurasLineales.ListaEstatica;
import estructurasNoLineales.Matriz2;

import static estructurasLineales.TipoTabla.*;

public class PruebaListaDinamica {
    public static void main(String[] args) {
        ListaDinamica lista = new ListaDinamica();
        ListaEstatica listaEstatica = new ListaEstatica(5);
        listaEstatica.agregar("A");
        listaEstatica.agregar("B");
        listaEstatica.agregar("C");
        listaEstatica.agregar("D");
        listaEstatica.agregar("E");
        SalidaPorDefecto.consola("-----AGREGAR VALORES-----\n");
        lista.agregar("F");
        lista.agregar("D");
        lista.agregar("A");
        lista.agregar("S");
        lista.agregar("G");
        SalidaPorDefecto.consola("-----IMPRIMIR LISTA-----\n");
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----IMPRIMIR INVERSA-----\n");
        lista.imprimirOI();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----IMPRIMIR LISTA ESTATICA CON VALORES LISTA DINAMICA-----\n");
        ListaEstatica listaE = lista.aListaEstatica();
        listaE.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----LISTA ESTATICA SIN ELEMENTOS REPETIDOS-----\n");
        SalidaPorDefecto.consola("-Lista Estatica con valores de Lista dinamica: \n");
        listaE.imprimir();
        SalidaPorDefecto.consola("-Lista pasada como argumento: \n");
        listaEstatica.imprimir();
        SalidaPorDefecto.consola("-Lista Estatica sin valores repetidos: \n");
        ListaEstatica listaSinRepetidos = lista.aListaEstatica(listaEstatica);
        listaSinRepetidos.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----IMPRIMIR MATRIZ 2D CON VALORES LISTA DINAMICA-----\n");
        Matriz2 matriz2D = lista.aMatriz2D(5,5);
        matriz2D.imprimirXRenglones();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----BUSCAR VALORES-----\n");
        SalidaPorDefecto.consola("Buscando el valor: F ->" + lista.buscar("F") + "\n");
        SalidaPorDefecto.consola("Buscando el valor: G ->" + lista.buscar("G") + "\n");
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----AGREGAR LISTA-----\n");
        SalidaPorDefecto.consola("-Se agrego una lista estatica con los mismos valores de la lista dinamica\n");
        lista.agregarLista(listaE);
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----LISTA CLONADA-----\n");
        ListaDinamica listaClonada = (ListaDinamica) lista.clonar();
        listaClonada.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----LISTA CON VALORES DE MATRIZ-----\n");
        Matriz2 matriz = new Matriz2(2,2,"X");
        matriz.cambiar(0,0,"Z");
        matriz.cambiar(0,1,"Z");
        lista.agregarMatriz2D(matriz,FILA);
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----VACIAR LA LISTA-----\n");
        lista.vaciar();
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----RELLENAR LA LISTA LA LISTA-----\n");
        lista.rellenar(6,3);
        lista.agregar(7);
        lista.agregar(8);
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----CONTADOR DE VALORES REPETIDOS-----\n");
        SalidaPorDefecto.consola("Las veces que se repite en la lista el valor 6 son : "+lista.contar(6));
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----INVERTIR LA LISTA-----\n");
        lista.invertir();
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----CAMBIAR UN VALOR-----\n");
        lista.cambiar(1,"X");
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----CAMBIAR UN VALOR VIEJO POR UNO NUEVO-----\n");
        SalidaPorDefecto.consola("-Cambiar el valor 6 por el 3, 2 veces:\n");
        lista.cambiar(6,3,2);
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----OBTENER-----\n");
        SalidaPorDefecto.consola("Obtener el indice 4: "+lista.obtener(4));
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----ES IGUAL-----\n");
        SalidaPorDefecto.consola("La lista clon es igual a la lista actual: "+lista.esIgual(listaClonada));
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----ELIMINAR VALORES CON VALOR-----\n");
        SalidaPorDefecto.consola("Eliminando 8: " + lista.eliminar(8) + "\n");
        SalidaPorDefecto.consola("Eliminando 6: " + lista.eliminar(6) + "\n");
        lista.imprimir();
        SalidaPorDefecto.consola("\n");
        SalidaPorDefecto.consola("-----ELIMINAR VALORES CON INDICE-----\n");
        SalidaPorDefecto.consola("Eliminando Indice 0: " + lista.eliminarIndice(0) + "\n");
        lista.imprimir();
        SalidaPorDefecto.consola("\n");

    }
}
